#pragma once

class SampleUtils
{
public:
	SampleUtils(void);
	~SampleUtils(void);

	static AcDbObjectId getAssocNetwork(bool createIfNotExist,
										   AcDbDatabase* pDatabase);

	// Get the constraint Group
	static AcDbObjectId getConstraintGroup(AcDbObjectId btrId,
                                              bool  createIfDoesNotExist,
                                              const AcString& dictionaryKey);

	static AcDbObjectId 
    getConstraintGroup(AcDbDatabase  *pDatabase,
					   bool  createIfDoesNotExist);

	static Acad::ErrorStatus getSubentIDs(const AcDbEntity*      pEntity,
                        AcDb::SubentType       subentType,
                        AcArray<AcDbSubentId>& allSubentIds);

	static Acad::ErrorStatus addConstrainedGeometry(AcDbAssoc2dConstraintGroup *pConstGrp, const AcDbFullSubentPathArray& aPaths);

	static void evaluateNetwork();
	
	static Acad::ErrorStatus
    getNameAndExpressionFromDimension(const AcDbObjectId &dimId,
															 const AcDbAssocConstraintType &constraintType,
															 AcString &name,
															 AcString &expression);

	static Acad::ErrorStatus
    addNewVariableToAssocNetwork(const AcString &name,
														const AcString &expression,
														const AcDbObjectId &networkId,
														AcDbObjectId &varId,
														AcDbObjectId &varDepId);

	static Acad::ErrorStatus createDistanceConstraint(AcDistanceConstraint::DirectionType directionType,
		AcDbObjectId varDepId,
		AcDbObjectId dimDepId,
		AcConstrainedGeometry*& pConsGeom,
		AcDbFullSubentPath& subEntPath,
		const AcGeVector3d *pFixedDirection = NULL);
};
