﻿using System;
using System.Collections.Generic;
using System.Windows;
using Autodesk.Windows;
using System.Windows.Media.Imaging;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using MyUtilityFunctions;
using System.Windows.Media;
using System.Reflection;
using System.Windows.Input;

namespace CuiCustomControls
{
  #region MyColorGallery
  public class MyColorGallery : RibbonGallery
  {
    #region MyColorGalleryImplementation
    public MyColorGallery()
    {
      ItemTemplate = Module.Resources["MyColorGalleryItemTemplate"] as DataTemplate;

      Type type = typeof(Brushes);
      foreach (PropertyInfo pi in type.GetProperties())
      {
        MethodInfo mi = pi.GetGetMethod();
        Brush br = mi.Invoke(null, null) as Brush;

        if (br != null)
        {
          MyColorItem item = new MyColorItem();
          item.Text = pi.Name;
          item.Brush = br;
          Items.Add(item);
        }
      }

    
      if (Items.Count > 1)
        Current = Items[1];
    }
    #endregion
  }

  #region MyColorItem
  internal class MyColorItem : RibbonCommandItem, ICommand
  {
    public MyColorItem()
    {
      this.CommandHandler = this;
    }

    #region MyColorItemImplementation
    public Brush Brush
    {
      get { return mBrush; }
      set
      {
        //System.Windows.Controls.StackPanel s;
        
        if (mBrush == value)
          return;
        mBrush = value;
        NotifyPropertyChanged("Brush");
      }
    }

    Brush mBrush;
    #endregion

    #region MyColorItem Events
    public event EventHandler CanExecuteChanged;
    // this is called for each ribbon item, we can set whether it is allowed to call execute or not
    public bool CanExecute(object parameter)
    {
      return true;
    }
    // this command is executed when the item is selected
    public void Execute(object parameter)
    {
      ItemsControlCommandParameter commandParam = parameter as ItemsControlCommandParameter;
      MyColorItem colorItem = commandParam.Item as MyColorItem;
      MessageBox.Show("Color picked is " + colorItem.Brush.ToString());
    }
    #endregion
  }
  #endregion
  #endregion
}
